module Take
  module Lint

    # Manages linting source files when building.  Should be
    # interesting to see how this pans out.
    #
    # @abstract
    class Base

      # Initializes the base linter.  Requires only one parameter.
      #
      # @param file [Path] the file that will be linted.
      def initialize(file)
        @file = file
      end

      # Lints the given file.  Returns an array of lint errors, which
      # is used to give information about what could be fixed.
      #
      # @abstract
      # @return [Array<Take::Lint::Error>]
      def lint
        raise NotImplementedError
      end

    end
  end
end
