module Take
  class Project
    module Requirement
      class Header < Base

        default_action do |header, project|
          file = Tempfile.new(['test', '.c'])
          file.write("#include <#{header}>\n\nint main() " \
            "{ return 0; }\n")
          file.flush
          out = Tempfile.new(['test', ''])

          command = Command::Runner.new(project.env[:cc],
            "-o {out} {in} -fPIC")
          success = command.run(in: file.path, out: out.path) do |m|
            p m
          end.successful?

          file.close(true)
          out.close(true)
          success
        end
      end
    end
  end
end
