module Take
  class Project
    module Requirement
      class Library < Base

        default_action do |library, project|
          file = Tempfile.new(['test', '.c'])
          file.write("#include <stdlib.h>\n\nint main() " \
            "{ return 0; }\n")
          file.flush
          out = Tempfile.new(['test', ''])

          command = Command::Runner.new(project.env[:cc],
            "-o {out} {in} -fPIC -l{library}")
          success = command.run(in: file.path, library: library,
            out: out.path).successful?

          file.close(true)
          out.close(true)
          success
        end

      end
    end
  end
end
